# coding: utf-8

"""
    BoldSign API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1
    Contact: support@boldsign.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from boldsign.models.address import Address
from boldsign.models.model_date import ModelDate
from typing import Optional, Set, Tuple
from typing_extensions import Self
import io
from pydantic import StrictBool
from typing import Union

class IdDocument(BaseModel):
    """
    IdDocument
    """ # noqa: E501
    type: Optional[StrictStr] = None
    first_name: Optional[StrictStr] = Field(default=None, alias="firstName")
    last_name: Optional[StrictStr] = Field(default=None, alias="lastName")
    country: Optional[StrictStr] = None
    document_number: Optional[StrictStr] = Field(default=None, alias="documentNumber")
    address: Optional[Address] = None
    dob: Optional[ModelDate] = None
    issued_date: Optional[ModelDate] = Field(default=None, alias="issuedDate")
    expiration_date: Optional[ModelDate] = Field(default=None, alias="expirationDate")
    document_files: Optional[List[StrictStr]] = Field(default=None, alias="documentFiles")
    selfie_file: Optional[StrictStr] = Field(default=None, alias="selfieFile")
    __properties: ClassVar[List[str]] = ["type", "firstName", "lastName", "country", "documentNumber", "address", "dob", "issuedDate", "expirationDate", "documentFiles", "selfieFile"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        arbitrary_types_allowed=True,
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    def to_json_form_params(self, excluded_fields: Set[str] = None) -> List[Tuple[str, str]]:
        data: List[Tuple[str, str]] = []

        for key, value in self.to_dict(excluded_fields).items():
            if isinstance(value, (int, str, bool)):
                data.append((key, value))
            elif isinstance(value, list):
                for index, item in enumerate(value):
                    if(isinstance(item, (int, str, bool))):
                        data.append((f'{key}[{index}]', item))
                    else:
                        data.append((key, json.dumps(value[index], ensure_ascii=False)))
            else:
                data.append((key, json.dumps(value, ensure_ascii=False)))

        return data

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IdDocument from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, excluded_fields: Set[str] = None) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IdDocument from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "firstName": obj.get("firstName"),
            "lastName": obj.get("lastName"),
            "country": obj.get("country"),
            "documentNumber": obj.get("documentNumber"),
            "address": Address.from_dict(obj["address"]) if obj.get("address") is not None else None,
            "dob": ModelDate.from_dict(obj["dob"]) if obj.get("dob") is not None else None,
            "issuedDate": ModelDate.from_dict(obj["issuedDate"]) if obj.get("issuedDate") is not None else None,
            "expirationDate": ModelDate.from_dict(obj["expirationDate"]) if obj.get("expirationDate") is not None else None,
            "documentFiles": obj.get("documentFiles"),
            "selfieFile": obj.get("selfieFile")
        })
        return _obj

    @classmethod
    def init(cls, data: Any) -> Self:
        """
        Attempt to instantiate and hydrate a new instance of this class
        """
        if isinstance(data, str):
            data = json.loads(data)

        return cls.from_dict(data)

    @classmethod
    def openapi_types(cls) -> Dict[str, str]:
        return {
            "type": "(str,)",
            "first_name": "(str,)",
            "last_name": "(str,)",
            "country": "(str,)",
            "document_number": "(str,)",
            "address": "(Address,)",
            "dob": "(ModelDate,)",
            "issued_date": "(ModelDate,)",
            "expiration_date": "(ModelDate,)",
            "document_files": "(List[str],)",
            "selfie_file": "(str,)",
        }

    @classmethod
    def openapi_type_is_array(cls, property_name: str) -> bool:
        return property_name in [
            "document_files",
        ]

